package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.cnbm.admin.utils.BaseSupportUtils;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.ProductLevelDTO;
import com.cnbm.packing.entity.ProductLevel;
import com.cnbm.packing.mapper.ProductLevelMapper;
import com.cnbm.packing.service.ProductLevelServiceBiz;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 产品等级 表
 *
 * @author codeGenerator
 * @since 2023-12-21
 */
@Service
public class ProductLevelServiceBizImpl extends CrudServiceImpl<ProductLevelMapper, ProductLevel, ProductLevelDTO> implements ProductLevelServiceBiz {

    @Autowired
    private ProductLevelMapper mapper;
    
    @Override
    public QueryWrapper<ProductLevel> getWrapper(Map<String, Object> params){
        String id = (String)params.get("id");

        QueryWrapper<ProductLevel> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id", id);

        return wrapper;
    }

    @Override
    public PageData<ProductLevelDTO> page (Map<String, Object> params){
        IPage<ProductLevel> page = baseDao.selectPage(
                getPage(params, ProductLevel.CREATE_TIME, false),
                getWrapper(params)
        );
        return getPageData(page, ProductLevelDTO.class);
    }

    @Override
    public ProductLevelDTO get(Long id) {
        ProductLevel entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, ProductLevelDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(ProductLevelDTO dto) {
        ProductLevel entity = ConvertUtils.sourceToTarget(dto, ProductLevel.class);
        BaseSupportUtils.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(ProductLevelDTO dto) {
        ProductLevel entity = ConvertUtils.sourceToTarget(dto, ProductLevel.class);
        BaseSupportUtils.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<ProductLevelDTO> list() {
        List<ProductLevelDTO> list = mapper.list();
        return list;
    }


}