package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.cnbm.admin.utils.BaseSupportUtils;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.ScenesDTO;
import com.cnbm.packing.entity.Scenes;
import com.cnbm.packing.mapper.ScenesMapper;
import com.cnbm.packing.service.ScenesServiceBiz;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 场景 表
 *
 * @author codeGenerator
 * @since 2023-12-21
 */
@Service
public class ScenesServiceBizImpl extends CrudServiceImpl<ScenesMapper, Scenes, ScenesDTO> implements ScenesServiceBiz {

    @Autowired
    private ScenesMapper mapper;
    
    @Override
    public QueryWrapper<Scenes> getWrapper(Map<String, Object> params){
        String id = (String)params.get("id");

        QueryWrapper<Scenes> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id", id);

        return wrapper;
    }

    @Override
    public PageData<ScenesDTO> page (Map<String, Object> params){
        IPage<Scenes> page = baseDao.selectPage(
                getPage(params, Scenes.CREATE_TIME, false),
                getWrapper(params)
        );
        return getPageData(page, ScenesDTO.class);
    }

    @Override
    public ScenesDTO get(Long id) {
        Scenes entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, ScenesDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(ScenesDTO dto) {
        Scenes entity = ConvertUtils.sourceToTarget(dto, Scenes.class);
        BaseSupportUtils.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(ScenesDTO dto) {
        Scenes entity = ConvertUtils.sourceToTarget(dto, Scenes.class);
        BaseSupportUtils.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<ScenesDTO> list() {
        List<ScenesDTO> list = mapper.list();
        return list;
    }


}